/*! Seppiko SableCSS Normalize | MIT License | https://sablecss.seppiko.org */
@use "sable";

// A better box model
::before,
::after {
  @include sable.layo-box-sizing(border-box);
  @include sable.border-border-none();
}

// 1. Prevent adjustments of font size after orientation changes in iOS.
// 2. Use a more readable tab size (opinionated).
html {
  -webkit-text-size-adjust: 100%; // 1
  @include sable.fun-prefix('tab-size', 4, 'moz'); // 2
}

// 1. Remove the margin in all browsers.
// 2. Set size for body on screen.
// 3. Correct the line height in all browsers.
// 4. Reset font size and weight.

body {
  @include sable.spac-margin-none(); // 1
  @include sable.spac-padding-none(); // 1
  @include sable.size-width(100%); // 2
  @include sable.size-min-height(100%); // 2

  @include sable.typo-line-height(1.15); // 3
  @include sable.typo-font-size(1rem); // 4
  @include sable.typo-font-weight(normal); // 4
}

// Render consistently in all browser.
header,
main,
footer,
nav,
section,
article,
aside {
  @include sable.layo-display(block);
}

// Reset list margin and padding
ol, ul {
  @include sable.spac-margin-none();
  @include sable.spac-padding-none();
}

// 1. Add the correct height in Firefox.
// 2. Correct the inheritance of border color in Firefox. (https://bugzilla.mozilla.org/show_bug.cgi?id=190655)
// 3. Show the overflow in Edge and IE.
// 4. Reset opacity
// 5. Reset margin and padding
hr {
  @include sable.size-height(0); // 1
  @include sable.typo-color(); // 2
  //@include sable.layo-box-sizing(content-box);
  @include sable.layo-overflow(visible); // 3
  //@include sable.border-border-style(solid);
  @include sable.typo-opacity(1); // 4
  @include sable.spac-margin-none(); // 5
  @include sable.spac-padding-none(); // 5
}

// Add the correct text decoration in Chrome, Edge, and Safari.
abbr[title] {
  @include sable.typo-text-decoration(underline dotted);
}

// Add the correct font weight in Edge and Safari.
b,
strong {
  @include sable.typo-font-weight(bolder);
}

// 1. Improve consistency of default fonts in all browsers.
// 2. Correct the odd 'em' font sizing in all browsers.
code,
kbd,
samp,
pre {
  @include sable.typo-mono-font(); // 1
  @include sable.typo-font-size(1em); // 2
}

// Add the correct font size in all browsers.
small {
  @include sable.typo-font-size(80%);
}

// Prevent 'sub' and 'sup' elements from affecting the line height in all browsers.
sub,
sup {
  @include sable.typo-font-size(75%);
  @include sable.typo-line-height(0);
  @include sable.layo-position(relative);
  @include sable.typo-vertical-align(baseline);
}

sub {
  @include sable.layo-bottom(-.25em);
}

sup {
  @include sable.layo-top(-.5em);
}

// 1. Remove text indentation from table contents in Chrome and Safari.
//    (https://bugs.chromium.org/p/chromium/issues/detail?id=999088, https://bugs.webkit.org/show_bug.cgi?id=201297)
// 2. Correct table border color inheritance in all Chrome and Safari.
//    (https://bugs.chromium.org/p/chromium/issues/detail?id=935729, https://bugs.webkit.org/show_bug.cgi?id=195016)
table {
  text-indent: 0; // 1
  @include sable.border-border-color(); // 2
}

// 1. Change the font styles in all browsers.
// 2. Remove the margin in Firefox and Safari.
button,
input,
textarea,
select,
optgroup {
  @include sable.typo-inherit-font(); // 1
  @include sable.typo-font-size(100%);// 1
  @include sable.typo-line-height(1.15);// 1
  @include sable.spac-margin-none(); // 2
  @include sable.spac-padding-none(); // 2
  @include sable.layo-overflow(visible);
}

// Remove the inheritance of text transform in Edge and Firefox.
button,
select {
  @include sable.typo-text-transform(none);
}

// Correct the inability to style clickable types in iOS and Safari.
button,
[type='button'],
[type='reset'],
[type='submit'] {
  -webkit-appearance: button;
}

// 1. Correct the text wrapping in Edge.
// 2. Remove the padding so developers are not caught out when they zero out
//    `fieldset` elements in all browsers.
legend {
  @include sable.layo-box-sizing(border-box); // 1
  @include sable.layo-display(table); // 1
  @include sable.size-max-width(100%); // 1
  @include sable.typo-white-space(normal); // 1
  @include sable.spac-padding(0); // 2
}

// Add the correct vertical alignment in Chrome, Firefox, and Opera.
progress {
  @include sable.typo-vertical-align(baseline);
}

// 1. Correct the odd appearance in Chrome and Safari.
// 2. Correct the outline style in Safari.
[type='search'] {
  @include sable.fun-prefix-add-moz('appearance', textfield); // 1
  @include sable.border-outline-offset(-2px); // 2
}

// Add the correct display in Edge and Firefox.
details {
  @include sable.layo-display(block);
}

// Add the correct display in Chrome and Safari.
summary {
  @include sable.layo-display(list-item);
}

// Allow labels to use `margin` for spacing.
label {
  @include sable.layo-display(inline-block);
}

// Remove the inner border and padding in Firefox.
::-moz-focus-inner {
  @include sable.border-border-style(none);
  @include sable.spac-padding(0);
}

// Restore the focus styles unset by the previous rule.
:-moz-focusring {
  outline: 1px dotted ButtonText;
}

// Remove the additional ':invalid' styles in Firefox.
// https://github.com/mozilla/gecko-dev/blob/2f9eacd9d3d995c937b4251a5557d95d494c9be1/layout/style/res/forms.css#L728-L737
:-moz-ui-invalid {
  @include sable.fun-prefix('box-shadow', none, 'moz');
}

// Correct the cursor style of increment and decrement buttons in Safari.
::-webkit-inner-spin-button,
::-webkit-outer-spin-button {
  @include sable.size-height(auto);
}

// 1. Remove the inner padding in Chrome and Safari on macOS.
// 2. Correct the outline style in Safari.
::-webkit-search-decoration {
  @include sable.fun-prefix-only('appearance', none); // 1
  @include sable.border-outline-offset(-2px); // 2
}

// 1. Correct the inability to style clickable types in iOS and Safari.
// 2. Change font properties to 'inherit' in Safari.
::-webkit-file-upload-button {
  @include sable.fun-prefix-only('appearance', button); // 1
  @include sable.typo-inherit-font(); // 2
}

// Reset placeholder
::placeholder, ::-webkit-input-placeholder {
  @include sable.typo-color();
  @include sable.typo-opacity(1);
  @include sable.typo-font-size(1em);
}
